/*
**   UltimateIRCd - Ultimate Internet Relay Chat daemon, include/dynconf.h
**   Copyright (C) 1999 Carsten Munk
**
**   Rewritten for UltimateIRCd by ShadowRealm Creations.
**   Copyright (C) 1999-2000 Infomedia Inc.
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef	__dynconf_include__
#define __dynconf_include__


#define DYNCONF_H

/* config level */
#define DYNCONF_CONF_VERSION "1.1.1"
#define DYNCONF_NETWORK_VERSION "2.1.3"

typedef struct zNetwork		aNetwork;
struct	zNetwork {
	char 		*x_ircnetwork;
	char 		*x_ircnetwork_name;
	char 		*x_defserv;
	char 		*x_webpage;
	char 		*x_webpage_rules;
	char 		*x_KLINE_ADDRESS;
        unsigned	x_mode_x : 1;
	unsigned	x_net_clone_protection : 1;
	long 		x_net_clone_limit;
	unsigned	x_net_clone_limit_bypass : 1;
	unsigned	x_hide_ulines : 1;
	unsigned  	x_global_connects : 1;
	unsigned	x_network_proxyscan : 1;
	unsigned	x_network_proxyscan_notice : 1;
	unsigned	x_network_auto_protect : 1;
	char		*x_net_users_auto_join;
	char		*x_net_opers_auto_join;
	char 		*x_services_name;
	char 		*x_watchdog_name;
	char 		*x_statserv_name;
	char 		*x_locop_host;
	char 		*x_oper_host;
	char 		*x_admin_host;
	char 		*x_servadmin_host;
	char 		*x_servicesoper_host;
	char 		*x_servicesadmin_host;
	char 		*x_servicesroot_host;
	char 		*x_techadmin_host;
	char 		*x_netadmin_host;
	char 		*x_ircadmin_host;
	char 		*x_sbot_host;
	char 		*x_netmon_host;
	char 		*x_helpchan;
	char 		*x_net_enforcer;
	char 		*x_net_enforcer_userid;
	char 		*x_net_enforcer_host;
	char 		*x_net_enforcer_realname;
	char 		*x_net_enforcer_server;
	char 		*x_net_enforcer_server_name;
};

typedef struct zConfiguration aConfiguration;
struct	zConfiguration {
	unsigned	halfhub : 1;
	unsigned	truehub : 1;
	long		client_flood;
	char 		*geo_location;
	unsigned	def_mode_i : 1;
	unsigned	def_mode_s : 1;
	unsigned	def_mode_w : 1;
	unsigned	short_motd : 1;
	unsigned	stop : 1;
	char    	*include;
	aNetwork	network;
};


#ifndef DYNCONF_C
extern	aConfiguration iConf;
#endif


/*
**
** ircd.ini defines
**
*/

#define PORTNUM 			iConf.portnum
#define HALFHUB				iConf.halfhub
#define TRUEHUB				iConf.truehub
#define CLIENT_FLOOD			iConf.client_flood
#define geo_location			iConf.geo_location    
#define DEF_MODE_I			iConf.def_mode_i
#define DEF_MODE_S			iConf.def_mode_s
#define DEF_MODE_W			iConf.def_mode_w
#define SHORT_MOTD			iConf.short_motd
#define INCLUDE				iConf.include


/*
**
** *.network defines
**
*/

#define ircnetwork			iConf.network.x_ircnetwork
#define ircnetwork_name			iConf.network.x_ircnetwork_name
#define	defserv				iConf.network.x_defserv
#define webpage				iConf.network.x_webpage
#define webpage_rules			iConf.network.x_webpage_rules
#define KLINE_ADDRESS			iConf.network.x_KLINE_ADDRESS
#define MODE_x				iConf.network.x_mode_x
#define net_clone_protection		iConf.network.x_net_clone_protection
#define net_clone_limit			iConf.network.x_net_clone_limit
#define net_clone_limit_bypass		iConf.network.x_net_clone_limit_bypass
#define HIDE_ULINES			iConf.network.x_hide_ulines
#define GLOBAL_CONNECTS			iConf.network.x_global_connects
#define network_proxyscan		iConf.network.x_network_proxyscan
#define network_proxyscan_notice	iConf.network.x_network_proxyscan_notice
#define network_auto_protect		iConf.network.x_network_auto_protect
#define net_users_auto_join		iConf.network.x_net_users_auto_join
#define net_opers_auto_join		iConf.network.x_net_opers_auto_join
#define services_name			iConf.network.x_services_name
#define watchdog_name			iConf.network.x_watchdog_name
#define statserv_name			iConf.network.x_statserv_name
#define locop_host			iConf.network.x_locop_host
#define oper_host			iConf.network.x_oper_host
#define admin_host			iConf.network.x_admin_host
#define servadmin_host			iConf.network.x_servadmin_host
#define servicesoper_host		iConf.network.x_servicesoper_host
#define servicesadmin_host		iConf.network.x_servicesadmin_host
#define servicesroot_host		iConf.network.x_servicesroot_host
#define techadmin_host			iConf.network.x_techadmin_host
#define netadmin_host			iConf.network.x_netadmin_host
#define ircadmin_host			iConf.network.x_ircadmin_host
#define sbot_host			iConf.network.x_sbot_host
#define netmon_host			iConf.network.x_netmon_host
#define helpchan			iConf.network.x_helpchan
#define net_enforcer			iConf.network.x_net_enforcer
#define net_enforcer_userid		iConf.network.x_net_enforcer_userid
#define net_enforcer_host		iConf.network.x_net_enforcer_host
#define net_enforcer_realname		iConf.network.x_net_enforcer_realname
#define net_enforcer_server		iConf.network.x_net_enforcer_server
#define net_enforcer_server_name	iConf.network.x_net_enforcer_server_name



/*
**
** general defines
**
*/

#define Network				ircnetwork


#endif /* __dynconf_include__ */
