/*   UltimateIRCd - Ultimate Internet Relay Chat Daemon, src/s_remote.c
**
**   Written for UltimateIRCd by ShadowRealm Creations.
**   Copyright (C) 1997-2000 Infomedia Inc.
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
**
** Using the same includes as in s_serv.c as we are doing
** pretty much the same things. - HAMLET
**
*/

#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include "userload.h"
#if defined(PCS) || defined(AIX) || defined(DYNIXPTX) || defined(SVR3)
#include <time.h>
#endif
#include <sys/stat.h>
#include <fcntl.h>
#ifndef _WIN32
#include <utmp.h>
#else
#include <io.h>
#endif
#include <time.h>
#include "h.h"

/*
**
** m_remrehash
**
*/
int	m_remrehash(cptr, sptr, parc, parv)
aClient	*cptr, *sptr;
int	parc;
char	*parv[];
{
	int  tagnum = getrandom(1, 12);
	char tagbuf[256];


        if (MyClient(sptr) && !OPCanRehash(sptr))
		{
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	    	}

       if (!IsNetAdmin(sptr) && !IsTechAdmin(sptr))
		{
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	    	}

        if (parc < 2)
		{
	   sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
                           me.name, parv[0], "REMREHASH");
                return 0;
	  	}

	if (tagnum == 1)
	{
		strcpy(tagbuf, "Clearing out the temp k-Lines while whistling innocently.");
	}

	if (tagnum == 2)
	{
		strcpy(tagbuf, "Messing with things he possibly shouldnt.");
	}

	if (tagnum == 3)
	{
		strcpy(tagbuf, "Tweaking server settings.");
	}

	if (tagnum == 4)
	{
		strcpy(tagbuf, "/REHASH - it slices, dices, and even reloads config files!");
	}

	if (tagnum == 5)
	{
		strcpy(tagbuf, "Cows fly high on tuesdays, not wednesdays. Remember that.");
	}


	if (tagnum == 6)
	{
		strcpy(tagbuf, "UltimateIRCd.. it just keeps going and going and going and goi *BOOM* awww shucks.. someone call the Net Admin, time for a beating.");
	}

	if (tagnum == 7)
	{
		strcpy(tagbuf, "Please add 3 quarters for the next 5 rehashes.");
	}

	if (tagnum == 8)
	{
		strcpy(tagbuf, "Please add more hamsters to the turn wheel for faster rehashes and less lag.");
	}

	if (tagnum == 9)
	{
		strcpy(tagbuf, "Please refrain from feeding the IRC Operators. Thank you.");
	}

	if (tagnum == 10)
	{
		strcpy(tagbuf, "Have you hugged your IRCd coder today?");
	}

	if (tagnum == 11)
	{
		strcpy(tagbuf, "New Chan Modes: basic = peon, +v = peons with a say, +h = wannabe head peons, +o = head peons, +b = bad peons, +e = blessed peon.");
	}

	if (tagnum == 12)
	{
		strcpy(tagbuf, "Now selling Server Admin positions for $50 a piece. Take advantage of this opportunity.");
	}

	if (parc == 2)
	{
		if (hunt_server(cptr,sptr,":%s REMREHASH :%s",1,parc,parv)==HUNTED_ISME)
		{
		sendto_one(sptr, rpl_str(RPL_REHASHING), me.name, parv[0], configfile);
		sendto_ops("\2[\2Server configuration file remotely rehashed by %s\2]\2 Random Quote: %s", parv[0], tagbuf);
		sendto_serv_butone(&me, ":%s NETINFO :%s is remotely rehashing the server configuration file on %s. Random Quote: %s", me.name, parv[0], me.name, tagbuf);

		#ifdef USE_SYSLOG
		syslog(LOG_INFO, "REMREHASH From %s\n", get_client_name(sptr, FALSE));
		#endif
		return rehash(cptr, sptr, 0);
		}
		else
		{
		return 0;
		}
	}
	else
	{
		if (hunt_server(cptr,sptr,":%s REMREHASH %s :%s",2,parc,parv)==HUNTED_ISME)
		{
			/*
			**
			** Rehash the dynamic configuration files - HAMLET
			**
			*/
			if (stricmp(parv[1], "dynconf")==0)
			{
				sendto_one(sptr, rpl_str(RPL_REHASHING), me.name, parv[0], DCONF);
				sendto_ops("\2[\2Dynamic Configuration files remotely rehashed by %s\2]\2 Random Quote: %s", parv[0], tagbuf);
				sendto_serv_butone(&me, ":%s NETINFO :%s is remotely rehashing the dynamic configuration files on %s. Random Quote: %s", me.name, parv[0], me.name, tagbuf);
				load_conf(DCONF, 1);
       				return 0;

			}
			else if (stricmp(parv[1], "channels")==0)
			{
				sendto_one(sptr, rpl_str(RPL_REHASHING), me.name, parv[0], "ircd.channels");
				sendto_ops("\2[\2Channel Restriction Configuration files remotely rehashed by %s\2]\2 Random Quote: %s", parv[0], tagbuf);
				sendto_serv_butone(&me, ":%s NETINFO :%s is remotely rehashing the channel restriction configuration files on %s. Random Quote: %s", me.name, parv[0], me.name, tagbuf);
				cr_rehash();
       				return 0;
			}
			/*
			**
			** User apparently havent RTFM =) - HAMLET
			**
			*/
			else
			{
				sendto_one(sptr, ":%s NOTICE %s :*** Notice -- %s is not a supported REMREHASH parameter.", me.name, sptr->name, parv[1]);
				sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Currently supported REMREHASH parameters are:", me.name, sptr->name);
				sendto_one(sptr, ":%s NOTICE %s :*** Notice -- \2DYNCONF\2 - Rehashes the dynamic configuration files.", me.name, sptr->name);
				sendto_one(sptr, ":%s NOTICE %s :*** Notice -- \2CHANNELS\2 - Rehashes the channel restriction configuration file.", me.name, sptr->name);
				return 0;
			}
		}
		else
		{
		return 0;
		}
	return 0;
	}
return 0;

}
