#!/bin/sh
spitshell=cat
package=UltimateIRCd

echo "Extracting $package version.c..."

if test -r version.c
then
   generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c`
   if test ! "$generation" ; then generation=0; fi
else
   generation=0
fi

generation=`expr $generation + 1`


creation=`date | \
awk '{if (NF == 6) \
         { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
         { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/*
**   UltimateIRCd - Ultimate Internet Relay Chat Daemon, src/version.c
**   Copyright (C) 1990 Chelsea Ashley Dyerman
**
**   Rewritten for UltimateIRCd by ShadowRealm Creations.
**   Copyright (C) 1997-2001 Infomedia Inc.
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "version.h"
#include "common.h"

char *generation = "$generation";
char *creation = "$creation";
#define IRCDTOTALVERSION BASE_VERSION MAJOR_RELEASE MINOR_RELEASE REVISION RELEASE_NAME BETA_RELEASE PATCH1 PATCH2 PATCH3 PATCH4 PATCH5 PATCH6 PATCH7 PATCH8 PATCH9
char *version = IRCDTOTALVERSION;

char *credittext[] =
    {

	"\2~~~~~~ UltimateIRCd Credits ~~~~~~\2",
	"",
	"     \2~~ Thanks go out to: ~~\2",
	"",
	"\2All Admins And Networks Using UltimateIRCd\2",
	" - For your support, ideas, bugreports, flames",
	"   and for making us want to go on developing the IRCd and make it better.",
	"",
	"\2Marvie\2",
	" - For your friendship, for your love, for the endless hours you've spent with me.",
	"   For giving me the strenght trough tough times.",
	"",
	"\2Emerald\2",
	" - For all the things you have done for me.",
	"   For all the joy and happiness you brought into my life.",
	"   For being a bright and shining star in my life when no other light where in sight.",
	"",
	"\2DarkWolf\2",
	" - For always being there there for me, both with moral support and technical support",
	"   For being a good friend and caring for me.", 
	"",
	"\2DKay\2",
	" - For endless support with both Beta Testing and for",
	"   being there when i needed it.",
	"",
	"\2Serena\2",
	" - For always being there to pick up the pieces, and putting them back together again.",
	"",
	"\2Nak\2",
	" - Without you this would not exsist.",
	"",
	"\2Zave\2",
	" - For inspiration, being a good friend, letting me be in the Zaveland Chronicles,",
	"   and everything else you have done for me.",
	"",
	"\2WarNPeace\2",
	" - For constantly bugging me about bugs, typos etc and making sure i fixed them.",
	"   Always coming up with new ideas and suggestions, and most of allsupporting my work.",
	"",
	"\2HMetal\2",
	" - For all the hints and tips on coding you have given me trough the years.",
	"   Not to forget all the bugfixes and code snipits you have added to this IRCd.",
	"",
	"                \2~~ Also Thanks To: ~~\2",
	"",
	"Jarkko Oikarinen, The StarChat development Team, The Bahamut development Team,",
	"The Unreal development Team, Crash, RogerY, Binary, Nuclear-X, Snazzy,",
	"Kerrne, Derelict, Magic, Mayor, Allan, Auntie, ToyMaster, XT, ZJ, CM,",
	"JyNx, Benjamin SaNdMaN, Rascle, CJ, DodGeR, Pierre-Luc, Quinn, Dief, Dooley,",
	"StrikerST, n3rd and everyone who have added their code, advice and opinions",
	"to the development of this IRCd.",
	"",
	"\2~~~~~~~~~~~~~~~~~~~~~~~~\2",
	0,
    };

!SUB!THIS!
